<?php
/*
 *Plugin Name: SmilePayC2C(PAY)
 *Description: SmilePay 7-11 c2c Shipping
 * Version: 3.0.2
 * Author:  SmilePay
 * Author URI: http://www.smilepay.net
*/
 
/**
 * Check if WooCommerce is active
 */

if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
    add_action('plugins_loaded', 'Smilepayc2cp_shipping_method_init', 0);
 
    add_action('woocommerce_checkout_update_order_review','Smilepayc2cp_shipping_method_match');
    add_action('before_woocommerce_pay','Smilepayc2cp_shipping_method_match_orderpay');

    //te覡LoIڤ覡
    function Smilepayc2cp_shipping_method_match()
    {

        $packages = WC()->cart->get_shipping_packages();
      

        foreach ( $packages as $package_key => $package ) 
        {
            WC()->shipping()->load_shipping_methods( $package );
           
        }
        $shipping_methods =  WC()->shipping()->shipping_methods;
        $payment_gateways = WC()->payment_gateways();



        foreach($shipping_methods as $shipping_method)
        {
           if( $shipping_method->id == 'smilepay_711_c2c_shippingpay' && $shipping_method->get_instance_id() != 0)
           {
               $smilepay_c2cp_shipping_method =  $shipping_method;
            
               break;
           }
           
        }
        if( isset($smilepay_c2cp_shipping_method) &&  $smilepay_c2cp_shipping_method)
        {
            if($smilepay_c2cp_shipping_method->enabled!="yes")
                return;
            if($smilepay_c2cp_shipping_method->instance_settings['payment_filter_enabled']!="yes")
                return;
           
        }
        

        if(isset($_REQUEST['shipping_method'][0] ))
            $selected_shipping_method = $_REQUEST['shipping_method'][0] ;
        else
        {
            $chosen_methods = WC()->session->get( 'chosen_shipping_methods' );
            if(empty($chosen_methods))
                return;
            $selected_shipping_method = $chosen_methods[0]; 
        }
                
        foreach ( $payment_gateways as $payment_gateway ) {
             foreach ( $payment_gateway as $gateway ) {
                    if(strtolower($selected_shipping_method) == 'smilepay_711_c2c_shippingpay')
                    {
               
                        if($gateway->id != 'smilepayc2c')
                            $gateway->enabled = 'no';
                    }
                    else
                    {
                        if($gateway->id == 'smilepayc2c')
                            $gateway->enabled = 'no';
                    }

             }
        }
    
         
      
    }
    //te覡LoIڤ覡 b
    function Smilepayc2cp_shipping_method_match_orderpay()
    {
        global $wp;

        if ( isset( $_GET['pay_for_order']) && $_GET['pay_for_order'] == 'true') 
        {
            $order_id = $wp->query_vars['order-pay'];
           
            if($order_id)
            {
                $order = wc_get_order( $order_id ); 
                if(!$order)
                    return;
                //$packages = WC()->cart->get_shipping_packages();
                
                //make fake package for find shipping region
                $packages = array();
                $packages[0]['destination']['country']   =  $order->get_shipping_country();
			    $packages[0]['destination']['state']     =  $order->get_shipping_state();
			    $packages[0]['destination']['postcode']  =  $order->get_shipping_postcode();
			    $packages[0]['destination']['city']      =  $order->get_shipping_city();
			    $packages[0]['destination']['address']   =  $order->get_shipping_address_1();
			    $packages[0]['destination']['address_2'] =  $order->get_shipping_address_2();

              
               
                //load shipping method
                foreach ( $packages as $package_key => $package ) 
                {
                     WC()->shipping()->load_shipping_methods( $package );
                }

              
                $shipping_methods =  WC()->shipping()->shipping_methods;
                $payment_gateways = WC()->payment_gateways();
                
                    
                foreach($shipping_methods as $shipping_method)
                {

                    if( $shipping_method->id == 'smilepay_711_c2c_shippingpay' && $shipping_method->get_instance_id() != 0)
                    {
                        $smilepay_c2cp_shipping_method =  $shipping_method;
                        break;
                    }
                }

                if( isset($smilepay_c2cp_shipping_method) &&  $smilepay_c2cp_shipping_method)
                {
                    if($smilepay_c2cp_shipping_method->enabled!="yes")
                        return;
                    if($smilepay_c2cp_shipping_method->instance_settings['payment_filter_enabled']!="yes")
                        return;
                }
         
                $selected_shipping_method =    $order->has_shipping_method('smilepay_711_c2c_shippingpay');

                
                foreach ( $payment_gateways as $payment_gateway ) {
                    foreach ( $payment_gateway as $gateway ) {
                        if($selected_shipping_method)
                        {
               
                            if($gateway->id != 'smilepayc2c')
                                $gateway->enabled = 'no';
                        }
                        else
                        {
                            if($gateway->id == 'smilepayc2c')
                                $gateway->enabled = 'no';
                        }   

                    }
                }


            }
            else
                return;



        }
    }


	function  Smilepayc2cp_shipping_method_init() {


		if ( ! class_exists( 'WC_Smilepayc2cp_Shipping_Method' ) ) {
			class WC_Smilepayc2cp_Shipping_Method extends WC_Shipping_Method {

				public function __construct($instance_id = 0) {
                    include_once("smilepayc2c.php");

                    $this->instance_id 			 = absint( $instance_id );

                  
                    $smilepayc2cdata = new WC_SmilePayc2c();
                    
					$this->id                 = 'smilepay_711_c2c_shippingpay';
					$this->method_title       = __( 'SmilePay 7-11 Shipping(PAY)' ); 
                    $this->method_description    = u2bcp('7-11WӨfI');

                    //for woocommerce 2.6 modify
					//$this->enabled            = "yes";
                    $this->supports              = array(
			                                        'shipping-zones',
			                                        'instance-settings',
			                                        'instance-settings-modal',
		                                            );

                    if(isset($smilepayc2cdata->title) && !empty($smilepayc2cdata->title))
					    $this->title              = $smilepayc2cdata->title;//u2bcp("tRt7-11fI"); 
                    else
                        $this->title              = u2bcp("SmilePay 7-11WӨfI úO"); 
					$this->init();
            
				}

				public function init_form_fields() {  //x]m

					//for woocommerce 2.6 modify
					//$this->form_fields = array(
                    $this->instance_form_fields = array(
					/*	'enabled' => array(
							'title' => __(u2bcp("ҥ/"), 'woocommerce'),
							'type' => 'checkbox',
							'default' => 'yes',
                   			'label' =>  $this->title,
						),*/
						'fee' => array(
							'title'       => __(u2bcp('O'), 'woocommerce' ),
							'type'        => 'price',
							'description' => __( '', 'woocommerce' ),
							'default'     => '',
							'desc_tip'    => true,
							'placeholder' => wc_format_localized_price( 0 )
						),
						'fee_top' => array(
							'title'       => __(u2bcp('KBOe'), 'woocommerce' ),
							'type'        => 'price',
							'description' => __(u2bcp("F즹BɡAKBOAϥνЫOť"), 'woocommerce'),
							'desc_tip'    => true,
							'placeholder' => wc_format_localized_price( 0 )
						),
                        'min_total' => array(
							'title'       => u2bcp('̧COB'),
							'type'        => 'price',
							'description' => u2bcp('qBF즹]wBA~iHϥΦte覡AtBO'),
							'default'     => '',
						),					
                        'payment_filter_enabled' => array(
							'title' =>  u2bcp("SmilePay te覡ftIڤ覡Wh"),
                            'description' => __(u2bcp("}Ҧ\AbbɡAte覡OfIڡAIڤ覡ufIڡAYte覡OfIڡAhIڤ覡|X{fI"), 'woocommerce'),
							'type' => 'checkbox',
							'default' => 'yes',
                   			'label' => u2bcp("ҥ"),
						),			
						'hiddtext' => array(
							'title' => __(u2bcp('Wӯ¨f`Nƶ'), 'woocommerce'),
							'type' => 'hidden',
							'description' => __(u2bcp("ϥζWӯ¨f\Aݪ`NHUƶG
														<br><font color='red'>ҲնȤ䴩iSmilePay WӨfIڡjyҲաAнT{ҥ</font>							
														<br>1.ХSmilePayӮax}Ҩf\*<a target='_blank' href='http://www.smilepay.net/RVG.ASP'>Ӯax</a>*
														<br>2.bT<font color='red'>pq</font><font color='red'>X</font>Aӫ~ɷ|H²TqC
														<br>3.O̦߭qAiSmilePayӮaxo<font color='red'>fKNX</font>C
														<br>4.O̦߭qAiܭqƵI<font color='red'>}ҥfKAȳ</font>C														
														<br>5.бN<font color='red'>fKNX</font>ʷsWܰӫ~ƵAHQO̬dߪyAC
														<br>6.hаѾ\A<font color='red'>SmilePay</font>P<font color='red'>WooCommerceҲջ</font>C
														"), 'woocommerce'),
							'default' => __('', 'woocommerce')
						)         
					);
				}
 
				function init() {
					$this->init_form_fields(); 
					//$this->init_settings();
					$this->fee          = $this->get_option( 'fee' );
					$this->fee_top= $this->get_option( 'fee_top' );	
                    $this->min_total =$this->get_option('min_total');	
                    $this->payment_filter_enabled= $this->get_option( 'payment_filter_enabled' );									
					add_action( 'woocommerce_update_options_shipping_' . $this->id, array( $this, 'process_admin_options' ) );
                    add_action('woocommerce_after_checkout_validation', array( $this, 'checkout_validate' ),10,2);
				}
                function checkout_validate( $data, $errors )
                {
                   //$shipping_methods =$data['shipping_method'];
                    $chosen_shipping_methods = WC()->session->get( 'chosen_shipping_methods' );
                    $chosen_payment_method = WC()->session->get( 'chosen_payment_method' ); 
                    $find_shipping_method=FALSE;
                    foreach($chosen_shipping_methods as $shipping_method)
                    {
                        if($shipping_method == $this->id)
                        {
                            $find_shipping_method=TRUE;
                        }
                    }
                    if( $find_shipping_method)
                    {
                        
                        $username=$data['billing_first_name'].$data['billing_last_name'];
                        if( !preg_match("/[^a-zA-Z0-9 ]/",$username))
                        {
                            $limit_name_number =10;
                        }
                        else
                        {
                            $limit_name_number =5;
                        }
				        if(substr($data['billing_phone'],0,2)!="09"||mb_strlen($data['billing_phone'])!=10||mb_strlen( $username, "utf-8")>$limit_name_number){
                           $errors->add( 'shipping',u2bcp("<br>qܮ榡~Ad09XX123456(@10X)C<br>O̩mWiWL5ӦrA­^hiWL10ӦrCЦAT{C<br>"));
                   
				        }
                        if(strtolower($chosen_payment_method) != 'smilepayc2c' )
                        {
                           $errors->add( 'shipping',u2bcp("<br>Iڤ覡ܿ~Ate覡iӥIڤ覡AЧ󴫨@<br>"));
                        }
                    }

                }
				/**
				 * calculate_shipping function.
				 *
				 * @access public
				 * @param mixed $package
				 * @return void
				 */
				public function calculate_shipping( $package = array() ) {
					$shipping_total=0;
					$shipping_total=$this->fee;
					
					$fee_top=$this->fee_top;
					$total = WC()->cart->cart_contents_total;					
					if($total>=$fee_top AND $fee_top<>0 AND $fee_top<>NULL)
					{$shipping_total=0;}
					
					$rate = array(
						'id' => $this->id,
						'label' => $this->title,
						'cost' => $shipping_total
					);
                    if($total < $this->min_total)
                        return;
					// Register the rate
					$this->add_rate( $rate );
				}
                // O_C2CPBe
                // $order_id:qs
                public function isSelectedSmilepayC2Cp($order_id)
                {
                 
                    if(!isset($order_id) || empty($order_id))
                    {
                        return false;
                    }
                    
                    $order = new WC_Order($order_id);
     
                    if(!isset($order) || empty($order))
                        return false;

                    if(is_admin())
                    {
                        $shipping_methods = $order->get_shipping_methods();
		                $has_method = false;
                             
         
		                if ( empty( $shipping_methods ) ) {
			                return false;
		                }
                         

		                foreach ( $shipping_methods as $shipping_method ) {

                            

                            if ($shipping_method->get_method_id() == $this->id ) {
				                    return true;
			                }   
                            
			                
		                }
                        return FALSE;

                    }
                    else
                    {
                         if( $order->has_shipping_method($this->id ))
                            return true;
                        else
                            return false;
                    }
                   
                 }
			}
		}

	}
 
	add_action( 'woocommerce_shipping_init', 'Smilepayc2cp_shipping_method_init' );
    
 
	function add_Smilepayc2cp_shipping_method( $methods ) {
        //fill this->id for woocommerce2.6 modify
		//$methods[] = 'WC_Smilepayc2cp_Shipping_Method';
        $methods['smilepay_711_c2c_shippingpay'] = 'WC_Smilepayc2cp_Shipping_Method';
		return $methods;
	}
 
	add_filter( 'woocommerce_shipping_methods', 'add_Smilepayc2cp_shipping_method' );
}
function u2bcp($text)//eX
{	return iconv("big5","UTF-8",$text);}
function b2ucp($text)//gJƮw
{	return iconv("UTF-8","big5",$text);}
